#include <dos.h>
#include <stdio.h>
#include <conio.h>

/* Quickly written program to modify io stuff 
 * at the command line
 *
 * 11.08.02
 */

void print_help () {
	printf("io_write.exe :Technologic Systems: 11.08.02\n");
	printf("usage: io_write.exe [-h] -a adress <-v value> [-c||-s bit]\n");
	printf("a	I/O port (in hex)\n");
	printf("v	value to write(in hex)\n");
	printf("c	clear bit (0-7)\n");
	printf("s	set   bit (0-7)\n");
	printf("	all set/clear ops are Read,modify,write routines\n");
}

int main (int argc, char *argv[]){
	int c = 0;
	unsigned char bit, temp2, temp1;
	unsigned int address,value;
	char bitset = 0; //0 none, 1 clear, 2 set
	
	while ( --argc > 0 && (*++argv)[0] == '-')
		while ( c = *++argv[0])
			switch (c) {
				case 'h':
					print_help();
					return 0;
					break;
				case 'a':
					argc--;
					sscanf(*++argv, "%x", &address);
					break;
				case 'v':
					argc--;
					sscanf(*++argv, "%x", &value);
					break;
				case 'c':
					argc--;
					sscanf(*++argv, "%d", &bit);
					bitset = 1;
					break;
				case 's':
					argc--;
					sscanf(*++argv, "%d", &bit);
					bitset = 2;
					break;
			}

	if (bitset == 2){
		if ( (bit < 0) || (bit > 7) ) {
		    printf("sorry, bit number to set must be 0 through 7\n");
		    return -1;
		}
		temp2 = 1; temp2 = temp2 << bit;
		temp1 = inportb(address);
		temp1 |= temp2 ;
		outportb(address, temp1);
	} else if (bitset == 1) {
		if ( (bit < 0) || (bit > 7) ) {
		    printf("sorry, bit number to clear must be 0 through 7\n");
		    return -1;
		}
		temp2 = 1; temp2 = temp2 << bit; temp2 = ~temp2;
		temp1 = inportb(address);
		temp1 &= temp2;
		outportb(address, temp1);
	} else 
		//if not clearing/setting bits, then
		//just write out a byte to IO
		outportb(address, value);
		
	return 0;
}
